//#include "timer.h"
#include <util/delay.h>
#include "at8LCD.h"


void LCD_init()
{
  //set ddr for all pins used
  LCD_DDR  = 0xFE;
  LCD_PORT = 0xFE;
  //delay(300);
  _delay_ms(300);
  command(0x28);  // function set: 4 bits, 1 line, 5x8 dots
  command(0x0C);  // display control: turn display on, cursor off, no blinking
  command(0x06);  // entry mode set: increment automatically, display shift, right shift
  LCD_clear();
}

void command(uint8_t data)
{
  send(data, 0);
}

void LCD_clear()
{
  command(0x01);  // clear display, set cursor position to zero
  //delay(2);
  _delay_ms(2);
}

void LCD_write(uint8_t data) {
  send(data, 1);
}

void LCD_setCursor(int row, int col)
{
  int row_offsets[] = { 0x00, 0x40, 0x14, 0x54 };
  command(0x80 | (col + row_offsets[row]));
}

void LCD_home()
{
  command(0x02);  // set cursor position to zero
  //delay(2);
  _delay_ms(2);
}

void send(uint8_t data, bool mode)
{
  if (mode) LCD_PORT |=  _BV(RS) ;
  else      LCD_PORT &= ~_BV(RS);
  
//  LCD_PORT &= ~_BV(WR);

//high nibble

  //clear 4 bit bus
  LCD_PORT &= 0x0F;
  //write 4 bit bus
  LCD_PORT |= (data & 0xF0);
  
  //delay(2);
  _delay_ms(2);

  //bring enable high
  LCD_PORT |= _BV(EN);
  
//  delay(2);
  _delay_ms(2);  
  //bring  eneable low
  LCD_PORT &= ~_BV(EN);
  
 //low nibble

  //clear 4 bit bus
  LCD_PORT &= 0x0F;
  
  //write 4 bit bus
  LCD_PORT |= (data & 0x0F)<<4;
 
  //delay(2);
  _delay_ms(2);

  //bring enable high
  LCD_PORT |= _BV(EN);
  //delay(2);
  _delay_ms(2); 
  //bring  eneable low
  LCD_PORT &= ~_BV(EN);
  
}
